#include <iostream>
#include <string>
#include <map>
using namespace std; 

int main() {
 map<string, int> nom_2_dni; 
 cout << nom_2_dni.size() << endl;

 
 /******** INSERT *******/
 pair<string, int> p1("Joan", 1234);
 nom_2_dni.insert(p1); 
 cout << nom_2_dni.size() << endl;
 nom_2_dni.insert(make_pair("Marta",5678));  
 nom_2_dni.insert(make_pair("Josep",1111));  
 nom_2_dni.insert(make_pair("Maria",1)); 
 cout << nom_2_dni.size() << endl;

 
 /***** RECORRIDO CON ITERADORES *******/
for (map<string,int>::const_iterator it = nom_2_dni.begin(); it != nom_2_dni.end(); ++it) { 
   cout << (*it).first << ": " << (*it).second << endl;
}


/********  INSERT en lugar de nom_2_dni["Maria"] = 2; *******/
// nom_2_dni["Maria"]=2; // sobreescribe
// insert no modifica el valor asociado a "Maria", pero nos
// informa de que existe un par con clave "Maria" asignando
// False a result.second. Además result.first apunta al par
// que tiene como clave "Maria". 
pair<map<string,int>::iterator, bool> result; 
result = nom_2_dni.insert(make_pair("Maria",2));
if (result.second) cout << "Maria insertada" << endl;
else cout << "Maria ya estaba " << (*(result.first)).second << endl; 

result = nom_2_dni.insert(make_pair("Lluis",2));
if (result.second) cout << "Lluis insertado" << endl;
else cout << "Lluis ya estaba " << (*(result.first)).second << endl; 

// recorremos de nuevo nom_2_dni para observar las modificaciones
cout << endl << endl;
for (map<string,int>::const_iterator it = nom_2_dni.begin(); it != nom_2_dni.end(); ++it) { 
   cout << (*it).first << ": " << (*it).second << endl;
}


 
// ********  FIND *******
string nombre; 
cin >> nombre; 
map<string,int>::const_iterator it; 
it = nom_2_dni.find(nombre); 
if (it == nom_2_dni.end()) cout << nombre << " no esta" << endl;
else cout << nombre << ": " << (*it).second << endl; 


 
 // ******* ERASE ******
cin >> nombre; 
int i = nom_2_dni.erase(nombre);  
if (i == 0) cout << nombre << " no  estaba" << endl;
else cout << nombre << " borrado" << endl;

// Ejemplo de borrar pares del map con dni impar
map<string,int>::iterator it2 = nom_2_dni.begin();
while (it2 != nom_2_dni.end()) {
   if (((*it2).second)%2 == 0) ++it2; 
   else it2 = nom_2_dni.erase(it2);
   // erase no sólo borra el elemento al que apunta it2, también
   // devuleve un iterador que apunta al siguiente elemento al que
   // apuntaba it2. Si it2 apuntaba al último elemento, erase devuelve
   // nom_2_dni.end().
}

for (map<string,int>::const_iterator it = nom_2_dni.begin(); it != nom_2_dni.end(); ++it) { cout << (*it).first << ": " << 
                (*it).second << endl;
}



//  ** CONSULTAR VALOR ***

 cout << nom_2_dni["Josep"] << endl; // coste log n
 cout << nom_2_dni["Nuria"] << endl; // Si Nuria no pertenece al map crea un par (Nuria,0) y lo inserta en el map.


for (map<string,int>::const_iterator it = nom_2_dni.begin(); it != nom_2_dni.end(); ++it) { cout << (*it).first << ": " << 
                (*it).second << endl;
}



}     
     
     
     
     
